<?php
#####################################################################################################
#
#					Module pour la plateforme de paiement PayZen
#						Version : 1.1a (révision 51616)
#									########################
#					Développé pour OpenCart_multi
#						Version : 1.5.5.1
#						Compatibilité plateforme : V2
#									########################
#					Développé par Lyra Network
#						http://www.lyra-network.com/
#						24/09/2013
#						Contact : support@payzen.eu
#
#####################################################################################################

class ControllerPaymentPayzenMulti extends Controller {
	private $error = array();
	private $_name = 'payzen_multi';
	
	public function index() {
		// loading language : opencart 1.5.5.x code compatibility
		if ((VERSION == '1.5.5') || (substr(VERSION, 0, -2) == '1.5.5')) {
			$this->language->load('payment/' . $this->_name);
		} else {
			$this->load->language('payment/' . $this->_name);
		}
		
		$this->document->setTitle($this->language->get('heading_title'));
		$this->load->model('setting/setting');
		
		if ($this->request->server['REQUEST_METHOD'] == 'POST' && $this->validate()) {
			if (isset($this->request->post['payzen_multi_available_languages']) && !empty($this->request->post['payzen_multi_available_languages'])) {
				$this->request->post['payzen_multi_available_languages'] = implode(';', $this->request->post['payzen_multi_available_languages']);
			} else {
				$this->request->post['payzen_multi_available_languages'] = '';
			}
			
			if (isset($this->request->post['payzen_multi_payment_cards']) && !empty($this->request->post['payzen_multi_payment_cards'])) {
				$this->request->post['payzen_multi_payment_cards'] = implode(';', $this->request->post['payzen_multi_payment_cards']);
			} else {
				$this->request->post['payzen_multi_payment_cardss'] = '';
			}
			
			$this->model_setting_setting->editSetting('payzen_multi', $this->request->post);				
			$this->session->data['success'] = $this->language->get('text_update_success');
			$this->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token']);
		}
		
		/**
		 * load language constants
		 * */
		$this->data['heading_title'] = $this->language->get('heading_title');
		
		$this->data['text_payzen_multi_yes'] = $this->language->get('text_payzen_multi_yes');
		$this->data['text_payzen_multi_no'] = $this->language->get('text_payzen_multi_no');
		$this->data['text_payzen_multi_default'] = $this->language->get('text_payzen_multi_default');
		$this->data['text_payzen_multi_automatic'] = $this->language->get('text_payzen_multi_automatic');
		$this->data['text_payzen_multi_manual'] = $this->language->get('text_payzen_multi_manual');
		
		$this->data['tab_payzen_multi_module_info'] = $this->language->get('tab_payzen_multi_module_info');
        $this->data['tab_payzen_multi_module_setting'] = $this->language->get('tab_payzen_multi_module_setting');
        $this->data['tab_payzen_multi_payment_access'] = $this->language->get('tab_payzen_multi_payment_access');
        $this->data['tab_payzen_multi_payment_page'] = $this->language->get('tab_payzen_multi_payment_page');
        $this->data['tab_payzen_multi_selective_3ds'] = $this->language->get('tab_payzen_multi_selective_3ds');
        $this->data['tab_payzen_multi_amount_restrictions'] = $this->language->get('tab_payzen_multi_amount_restrictions');
        $this->data['tab_payzen_multi_installment_options'] = $this->language->get('tab_payzen_multi_installment_options');
        $this->data['tab_payzen_multi_return_to_shop'] = $this->language->get('tab_payzen_multi_return_to_shop');
        
        $this->data['entry_payzen_multi_developed_by'] = $this->language->get('entry_payzen_multi_developed_by');
        $this->data['entry_payzen_multi_contact_email'] = $this->language->get('entry_payzen_multi_contact_email');
        $this->data['entry_payzen_multi_contrib_version'] = $this->language->get('entry_payzen_multi_contrib_version');
        $this->data['entry_payzen_multi_gateway_version'] = $this->language->get('entry_payzen_multi_gateway_version');
        $this->data['entry_payzen_multi_cms_version'] = $this->language->get('entry_payzen_multi_cms_version');

        $this->data['entry_payzen_multi_url_check'] = $this->language->get('entry_payzen_multi_url_check');
        
 		require_once(DIR_SYSTEM . 'library/payzen_multi.php');
 		$payzenApi = new PayzenMultiApi();
 		
 		// use supported API languages
 		$this->data['payzen_multi_language_options'] = array();
 		foreach ($payzenApi->getSupportedLanguages() as $code => $label) {
 			$this->data['payzen_multi_language_options'][$code] = $this->language->get('text_payzen_multi_' . strtolower($label));
 		}
 		
 		// use supported API card types
 		$this->data['payzen_multi_payment_card_options'] = $payzenApi->getSupportedCardTypes();
 		
 		$this->data['text_enabled'] = $this->language->get('text_enabled');
 		$this->data['text_disabled'] = $this->language->get('text_disabled');
 		$this->data['text_all_zones'] = $this->language->get('text_all_zones');
		$this->data['button_save'] = $this->language->get('button_save');
		$this->data['button_cancel'] = $this->language->get('button_cancel');
		$this->data['tab_general'] = $this->language->get('tab_general');
		
 		if (isset($this->error['warning'])) {
			$this->data['error_warning'] = $this->error['warning'];
		} else {
			$this->data['error_warning'] = '';
		}
		
   		$this->data['breadcrumbs'] = array();
   		$this->data['breadcrumbs'][] = array(
   				'text' => $this->language->get('text_home'),
   				'href' => $this->url->link('common/home', 'token=' . $this->session->data['token'], 'SSL'),
   		      	'separator' => false
   		);
   		$this->data['breadcrumbs'][] = array(
				'text' => $this->language->get('text_payment'),
				'href' => $this->url->link('extension/payment', 'token=' . $this->session->data['token'], 'SSL'),
   		      	'separator' => ' :: '
   		);
   		$this->data['breadcrumbs'][] = array(
				'text' => $this->language->get('heading_title'),
				'href' => $this->url->link('payment/payzen_multi', 'token=' . $this->session->data['token'], 'SSL'),      		
				'separator' => ' :: '
   		);
   		
		$this->data['action'] = HTTPS_SERVER . 'index.php?route=payment/payzen_multi&token=' . $this->session->data['token'];
		$this->data['cancel'] = HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token'];
		
		$configParams = array(
				'status', 'sort_order', 'geo_zone',
				'site_id', 'key_test', 'key_prod', 'ctx_mode', 'platform_url', 'language', 'available_languages', 
				'capture_delay', 'validation_mode', 'payment_cards', '3ds_min_amount', 'minimum_amount', 'maximum_amount',
				'first', 'count', 'period', 
				'redirect_enabled', 'redirect_success_timeout', 'redirect_success_message', 'redirect_error_timeout', 
				'redirect_error_message', 'return_mode', 'order_status_success', 'order_status_failed', 'order_status_canceled',
				'notify_failed', 'notify_canceled'
		);
		
		foreach ($configParams as $name) {
			// load config parameter values
			if (isset($this->request->post['payzen_multi_' . $name])) {
				$this->data['payzen_multi_' . $name] = $this->request->post['payzen_multi_' . $name];
			} else {
				$this->data['payzen_multi_' . $name] = $this->config->get('payzen_multi_' . $name);
			}
			
			// load language constants
			$this->data['entry_payzen_multi_' . $name] = $this->language->get('entry_payzen_multi_' . $name);
			$this->data['desc_payzen_multi_' . $name] = $this->language->get('desc_payzen_multi_' . $name);
		}
		
		// load order statuses		
		$this->load->model('localisation/order_status');
		$this->data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();
		
		// load geographic zones
		$this->load->model('localisation/geo_zone');
		$this->data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();
		
		$this->template = 'payment/payzen_multi.tpl';
		$this->children = array(
				'common/header',	
				'common/footer'	
		);
		$this->response->setOutput($this->render(TRUE), $this->config->get('config_compression'));
	}

	private function validate() {
		if (!$this->user->hasPermission('modify', 'payment/payzen_multi')) {
			$this->error['warning'] = $this->language->get('error_permission');
		} elseif (isset($this->request->post['payzen_multi_first']) && !preg_match('#^(\d\d?)?$#', $this->request->post['payzen_multi_first'])) {
			$this->error['warning'] = sprintf($this->language->get('error_payzen_multi_validation'), $this->language->get('entry_payzen_multi_first'));
		} elseif (!isset($this->request->post['payzen_multi_count']) || empty($this->request->post['payzen_multi_count']) || !is_numeric($this->request->post['payzen_multi_count'])) {
			$this->error['warning'] = sprintf($this->language->get('error_payzen_multi_validation'), $this->language->get('entry_payzen_multi_count'));
		} elseif(!isset($this->request->post['payzen_multi_period']) || empty($this->request->post['payzen_multi_period']) || !is_numeric($this->request->post['payzen_multi_period'])) {
			$this->error['warning'] = sprintf($this->language->get('error_payzen_multi_validation'), $this->language->get('entry_payzen_multi_period'));
		}
		
		return !$this->error ? TRUE : FALSE;
	}
	
	public function install() {
		// loading language : opencart 1.5.5.x code compatibility
		if ((VERSION == '1.5.5') || (substr(VERSION, 0, -2) == '1.5.5')) {
			$this->language->load('payment/' . $this->_name);
		} else {
			$this->load->language('payment/' . $this->_name);
		}
		
		$this->data['payzen_multi_status'] = '1';
		$this->data['payzen_multi_sort_order'] = '1';
		$this->data['payzen_multi_geo_zone'] = '0';
		
		$this->data['payzen_multi_site_id'] = '12345678';
		$this->data['payzen_multi_key_test'] = '1111111111111111'; 
		$this->data['payzen_multi_key_prod'] = '2222222222222222';
		$this->data['payzen_multi_ctx_mode'] = 'TEST';
		$this->data['payzen_multi_platform_url'] = 'https://secure.payzen.eu/vads-payment/';
		
		$this->data['payzen_multi_language'] = 'fr';

		$this->data['payzen_multi_count'] = '3';
		$this->data['payzen_multi_period'] = '30';
		
		$this->data['payzen_multi_redirect_enabled'] = '0';
 		$this->data['payzen_multi_redirect_success_timeout'] = '5';
 		$this->data['payzen_multi_redirect_success_message'] = 'Redirection vers la boutique dans quelques instants...';
 		$this->data['payzen_multi_redirect_error_timeout'] = '5';
 		$this->data['payzen_multi_redirect_error_message'] = 'Redirection vers la boutique dans quelques instants...';
 		$this->data['payzen_multi_return_mode'] = 'GET';
 		$this->data['payzen_multi_order_status_failed'] = '10';
 		$this->data['payzen_multi_order_status_success'] = '5';
 		$this->data['payzen_multi_order_status_canceled'] = '7';
 		$this->data['payzen_multi_notify_failed'] = '0';
 		$this->data['payzen_multi_notify_canceled'] = '0';
 		
		$this->load->model('setting/setting');
		$this->model_setting_setting->editSetting('payzen_multi', $this->data);				
		$this->session->data['success'] = $this->language->get('text_install_success');
		
		$this->redirect(HTTPS_SERVER . 'index.php?route=extension/payment&token=' . $this->session->data['token']);
	}
}
?>